function Anestecia_Automatic_Control()
clear all
% Call function to init the system control variables
global Figure_1 Fig_Simulator Grp_SETUP Grp_Controllers Button_SETUP Button_Controllers;
global Enabled_DATEX Enabled_Syringe_1 Enabled_Syringe_2  Enabled_Syringe_3;
global Grp_01 Grp_02 Grp_03 RB_Real_Time RB_Simulator hpop_Time_AXES;
global hpop_01 hpop_02 hpop_03 hpop_04 hpop_05 hpop_06 hpop_03_N hpop_04_N hpop_ST_01 hpop_ST_02 hpop_ST_03;
global u1 u2 u3 u4 u5 u6 u4_N u5_N u6_N  Ch_1 Ch_1A Ch_1B Ch_2 Ch_3 Ch_4 Ch_5 Ch_6 Ch_7 Ch_8 Ch_9;
global Button_Start Button_Stop Plot_1 Plot_2 Plot_3 VAR_ZOOM_1;
global Label_06 Label_09 Label_09_N Label_12 Label_13 Label_14 Label_15 Label_16 Label_17 Bar_T1 Bar_T2 Bar_T3 Bar_T4
global Button_01 Button_02 Button_02_N Label_26 Label_26a Label_27 Label_27A Label_27a Label_27C Label_27D Label_27E Edit_01 Edit_02 Edit_02_N;
global Timer_1 Timer_Pump_1 Timer_Pump_2 Timer_Pump_3 Timer_Simulator;
global Label_Point_Value Label_Point_Text Edit_Point_Text;
global hpop_Step Ed_Ymax Ed_Ymin;
Init_Variables ();

Figure_1 = figure( ...
    'PaperUnits','points', ...
    'Position',DefFigPos, ...
    'KeyPressFcn', 'figure(gcf)', ...
    'Color',Color_01,...
    'doublebuffer','on',...
    'CloseRequestFcn','my_closereq_01(1);',...
    'resize','off',...
    'NumberTitle','off',...
    'menubar','none',...
    'windowstyle','normal',...
    'Name', 'Automatic Control In Anesthesia');

Button_SETUP =uicontrol('Style', 'pushbutton',...
    'String', 'SETUP',...
    'Position', [50 567 45 20],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'FontWeight', 'bold',...
    'BackgroundColor','white',...
    'Callback', 'Function_Button_SETUP');

Button_Controllers =uicontrol('Style', 'pushbutton',...
    'String', 'CONTROLLERS',...
    'Position', [96 567 85 20],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Button_Controllers');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Create the button group.(SETUP) %%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Grp_SETUP = uibuttongroup('visible','on',...
    'backgroundcolor','white',...
    'Title', '',...
    'FontSize', 10,...
    'FontWeight', 'bold',...
    'Units', 'points',...
    'Position',[10 340 390 85]);

Label_DATEX =uicontrol('Style', 'text',...
    'String', 'DATEX:',...
    'Position', [4 61 50 15],...
    'BackgroundColor','white',...
    'Parent',Grp_SETUP,...
    'HorizontalAlignment','Right');

Label_PUMP_1 =uicontrol('Style', 'text',...
    'String', 'Syringe 1',...
    'Position', [4 41 50 15],...
    'BackgroundColor','white',...
    'Parent',Grp_SETUP,...
    'HorizontalAlignment','Right');

Label_PUMP_2 =uicontrol('Style', 'text',...
    'String', 'Syringe 2',...
    'Position', [4 21 50 15],...
    'BackgroundColor','white',...
    'Parent',Grp_SETUP,...
    'HorizontalAlignment','Right');


Label_PUMP_3 =uicontrol('Style', 'text',...
    'String', 'Syringe 3',...
    'Position', [4 1 50 15],...
    'BackgroundColor','white',...
    'Parent',Grp_SETUP,...
    'HorizontalAlignment','Right');

Label_01 =uicontrol('Style', 'text',...
    'String', 'Sampling T.',...
    'Position', [60 82 100 15],...
    'BackgroundColor','white',...
    'Parent',Grp_SETUP,...
    'HorizontalAlignment','Left');

Label_02 =uicontrol('Style', 'text',...
    'String', 'UDP-Local',...
    'Parent',Grp_SETUP,...
    'Position', [130 82 100 15],...
    'BackgroundColor','white',...
    'HorizontalAlignment','Left');

Label_03 =uicontrol('Style', 'text',...
    'String', 'UDP-Remote',...
    'Parent',Grp_SETUP,...
    'Position', [200 82 100 15],...
    'BackgroundColor','white',...
    'HorizontalAlignment','Left');

Label_03 =uicontrol('Style', 'text',...
    'String', 'Enable',...
    'Parent',Grp_SETUP,...
    'Position', [270 82 44 15],...
    'BackgroundColor','white',...
    'HorizontalAlignment','Left');

hpop_01 = uicontrol('Style', 'popup',...
    'String', '1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20',...
    'Position', [60 68 60 15],...
    'Parent',Grp_SETUP,...
    'Value',5,...
    'tag','Pop_Men_ST',...
    'Callback', 'Pop_Men_Fun_01');

hpop_02 = uicontrol('Style', 'popup',...
    'String', '11000|11001|11002|11003|11004|11005|11006|11007|11008|11009',...
    'Position', [130 68 60 15],...
    'Parent',Grp_SETUP,...
    'Value',1,...
    'tag','Pop_Men_DATEX_Port_Read',...
    'Callback', 'Pop_Men_Fun_02');

hpop_03 = uicontrol('Style', 'popup',...
    'String', '11000|11001|11002|11003|11004|11005|11006|11007|11008|11009',...
    'Position', [130 48 60 15],...
    'Value',2,...
    'Parent',Grp_SETUP,...
    'tag','Pop_Men_Pump1_Port_Read',...
    'Callback', 'Pop_Men_Fun_03');

hpop_04 = uicontrol('Style', 'popup',...
    'String', '11000|11001|11002|11003|11004|11005|11006|11007|11008|11009',...
    'Position', [200 48 60 15],...
    'Value',3,...
    'Parent',Grp_SETUP,...
    'tag','Pop_Men_Pump1_Port_Write',...
    'Callback', 'Pop_Men_Fun_04');


hpop_ST_01 = uicontrol('Style', 'popup',...
    'String', '1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20',...
    'Position', [60 48 60 15],...
    'Parent',Grp_SETUP,...
    'Value',5,...
    'tag','Pop_Men_Pump1_ST',...
    'Callback', 'Set_Sampling_Time_Pump_01');

hpop_05 = uicontrol('Style', 'popup',...
    'String', '11000|11001|11002|11003|11004|11005|11006|11007|11008|11009',...
    'Position', [130 28 60 15],...
    'Value',4,...
    'Parent',Grp_SETUP,...
    'tag','Pop_Men_Pump2_Port_Read',...
    'Callback', 'Pop_Men_Fun_05');

hpop_06 = uicontrol('Style', 'popup',...
    'String', '11000|11001|11002|11003|11004|11005|11006|11007|11008|11009',...
    'Position', [200 28 60 15],...
    'Value',5,...
    'Parent',Grp_SETUP,...
    'tag','Pop_Men_Pump2_Port_Write',...
    'Callback', 'Pop_Men_Fun_06');

hpop_ST_02 = uicontrol('Style', 'popup',...
    'String', '1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20',...
    'Position', [60 28 60 15],...
    'Parent',Grp_SETUP,...
    'Value',5,...
    'tag','Pop_Men_Pump2_ST',...
    'Callback', 'Set_Sampling_Time_Pump_02');

hpop_03_N = uicontrol('Style', 'popup',...
    'String', '11000|11001|11002|11003|11004|11005|11006|11007|11008|11009',...
    'Position', [130 8 60 15],...
    'Value',6,...
    'Parent',Grp_SETUP,...
    'tag','Pop_Men_Pump3_Port_Read',...
    'Callback', 'Pop_Men_Fun_07');

hpop_04_N = uicontrol('Style', 'popup',...
    'String', '11000|11001|11002|11003|11004|11005|11006|11007|11008|11009',...
    'Position', [200 8 60 15],...
    'Value',7,...
    'Parent',Grp_SETUP,...
    'tag','Pop_Men_Pump3_Port_Write',...
    'Callback', 'Pop_Men_Fun_08');

hpop_ST_03 = uicontrol('Style', 'popup',...
    'String', '1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20',...
    'Position', [60 8 60 15],...
    'Parent',Grp_SETUP,...
    'Value',5,...
    'tag','Pop_Men_Pump3_ST',...
    'Callback', 'Set_Sampling_Time_Pump_03');

Enabled_DATEX = uicontrol('Style','checkbox',...
    'value',1,...
    'tag','Check_1',...
    'pos',[270 68 15 15],...
    'parent',Grp_SETUP,...
    'Callback', 'Function_EN_DATEX');

Enabled_Syringe_1 = uicontrol('Style','checkbox',...
    'value',1,...
    'tag','Check_1',...
    'pos',[270 48 15 15],...
    'parent',Grp_SETUP,...
    'Callback', 'Function_EN_Syringe_1');


Enabled_Syringe_2 = uicontrol('Style','checkbox',...
    'value',1,...
    'tag','Check_1',...
    'pos',[270 28 15 15],...
    'parent',Grp_SETUP,...
    'Callback', 'Function_EN_Syringe_2');

Enabled_Syringe_3 = uicontrol('Style','checkbox',...
    'value',1,...
    'tag','Check_1',...
    'pos',[270 8 15 15],...
    'parent',Grp_SETUP,...
    'Callback', 'Function_EN_Syringe_3');

% Create the button group.(Operating Mode)
Grp_Op_Mode = uibuttongroup('visible','on',...
    'backgroundcolor','white',...
    'Title', 'Operating Mode',...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'parent',Grp_SETUP,...
    'Units', 'points',...
    'Position',[235 30 140 52],...
'SelectionChangeFcn', 'Function_Operating_Mode(1)');

RB_Real_Time = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Real Time',...
    'value',1,...
    'tag','Radio_Time',...
    'pos',[4 40 80 15],...
    'parent',Grp_Op_Mode,...
    'HandleVisibility','off');
    


RB_Simulator = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Simulation Mode',...
    'value',0,...
    'tag','Radio_Time',...
    'pos',[75 40 100 15],...
    'parent',Grp_Op_Mode,...
    'HandleVisibility','off');


Label =uicontrol('Style', 'text',...
    'String', 'Decoded Data File:',...
    'Position', [5 24 100 15],...
    'HorizontalAlignment','Left',...
    'Parent',Grp_Op_Mode,...
    'BackgroundColor','white');

Edit_DATA_FILE = uicontrol('Style', 'edit',...
    'String', '',...
    'parent',Grp_Op_Mode,...
    'Position', [5 10 100 15],...
    'HorizontalAlignment','left',...
    'Enable','off',...
    'BackgroundColor',Color_02,...
    'Callback', 'Function_Validate_INF_Rate_1');

Label =uicontrol('Style', 'text',...
    'String', 'Step (ms):',...
    'Position', [120 24 50 15],...
    'HorizontalAlignment','Left',...
    'Parent',Grp_Op_Mode,...
    'BackgroundColor','white');

hpop_Step = uicontrol('Style', 'popup',...
    'String', '100|200|500|1000|5000',...
    'Position', [120 10 50 15],...
    'Value',2,...
    'Parent',Grp_Op_Mode,...
    'Enable','off',...
    'tag','Pop_Men_Simulation_epSt',...
    'Callback', 'Pop_Men_Fun_03');

Label =uicontrol('Style', 'text',...
    'String', 'Time to show in AXES (min):',...
    'Position', [311 20 150 15],...
    'HorizontalAlignment','Left',...
    'Parent',Grp_SETUP,...
    'BackgroundColor','white');

hpop_Time_AXES = uicontrol('Style', 'popup',...
    'String', '15|30|60|90',...
    'Position', [450 24 50 15],...
    'Value',1,...
    'Parent',Grp_SETUP,...
    'Enable','on',...
    'tag','Pop_Men_Axes_Lim',...
    'Callback', 'Function_SET_Time_AXES');

Show_BIS_Toolbox = uicontrol('Style','checkbox',...
    'value',1,...
    'String', 'Show BIS Toolbox',...
    'pos',[315 5 120 15],...
    'parent',Grp_SETUP,...
    'BackgroundColor','white',...
    'Callback', 'Function_Show_BIS_Toolbox');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Button group BIS-Toolbox %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Grp_BIS_Toolbox = uibuttongroup('visible','on',...
    'Title', 'BIS Toolbox',...
    'backgroundcolor',get(gcf,'color'),...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'Visible','on',...
    'Units', 'points',...
    'Position',[405 340 92 75]);

Button_BTool_Select =uicontrol('Style', 'pushbutton',...
    'String', 'Select',...
    'parent',Grp_BIS_Toolbox,...
    'Position', [3 63 36 17],...
    'FontSize', 8,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Tool(1)');

Button_BTool_True =uicontrol('Style', 'pushbutton',...
    'String', 'True',...
    'parent',Grp_BIS_Toolbox,...
    'Position', [42 63 36 17],...
    'FontSize', 8,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Tool(2)');

Button_BTool_New =uicontrol('Style', 'pushbutton',...
    'String', 'New',...
    'parent',Grp_BIS_Toolbox,...
    'Position', [81 63 36 17],...
    'FontSize', 8,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Tool(3)');

Button_BTool_False =uicontrol('Style', 'pushbutton',...
    'String', 'False',...
    'parent',Grp_BIS_Toolbox,...
    'Position', [3 40 36 17],...
    'FontSize', 8,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Tool(4)');

Button_BTool_Delete =uicontrol('Style', 'pushbutton',...
    'String', 'Delete',...
    'parent',Grp_BIS_Toolbox,...
    'Position', [42 40 36 17],...
    'FontSize', 8,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Tool(5)');

Button_BTool_ESC =uicontrol('Style', 'pushbutton',...
    'String', 'Save',...
    'parent',Grp_BIS_Toolbox,...
    'Position', [81 40 36 17],...
    'FontSize', 8,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Tool(6)');

Label_Point =uicontrol('Style', 'text',...
    'String', 'X,Y: ',...
    'FontWeight', 'bold',...
    'Position', [13 18 20 15],...
    'HorizontalAlignment','Left',...
    'Parent',Grp_BIS_Toolbox,...
    'BackgroundColor',get(gcf,'color'));

Label_Point_Value =uicontrol('Style', 'text',...
    'String', '[]',...
    'FontWeight', 'bold',...
    'Position', [34 18 80 15],...
    'HorizontalAlignment','Left',...
    'Parent',Grp_BIS_Toolbox,...
    'BackgroundColor',get(gcf,'color'));

Label_Text =uicontrol('Style', 'text',...
    'String', 'Note: ',...
    'FontWeight', 'bold',...
    'Position', [5 3 28 15],...
    'HorizontalAlignment','Left',...
    'Parent',Grp_BIS_Toolbox,...
    'BackgroundColor',get(gcf,'color'));

Edit_Point_Text = uicontrol('Style', 'edit',...
    'String', '',...
    'parent',Grp_BIS_Toolbox,...
    'Position', [35 3 80 15],...
    'HorizontalAlignment','left',...
    'BackgroundColor',Color_02);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Create the button group.(Controllers) %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Grp_Controllers = uibuttongroup('visible','on',...
    'backgroundcolor','white',...
    'Title', '',...
    'FontSize', 10,...
    'FontWeight', 'bold',...
    'Visible','off',...
    'Units', 'points',...
    'Position',[10 340 390 85]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create the button group.(Syringe Pump 1)%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Grp_01 = uibuttongroup('visible','on',...
    'backgroundcolor','white',...
    'Title', 'Syringe - 1 (Enabled)',...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'Parent',Grp_Controllers,...
    'Units', 'points',...
    'Position',[5 2 120 80],...
    'SelectionChangeFcn','SelectionChangeFcn_Pump_1');

% Create three radio buttons in the button group.
u1 = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Monitoring',...
    'value',1,...
    'tag','Radio_1',...
    'pos',[4 75 100 15],...
    'parent',Grp_01,...
    'HandleVisibility','off');

u3 = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Automatic Control',...
    'pos',[4 60 110 15],...
    'tag','Radio_3',...
    'parent',Grp_01,...
    'HandleVisibility','off');

Label =uicontrol('Style', 'text',...
    'String', 'Set Point',...
    'parent',Grp_01,...
    'Position', [15 43 50 15],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'backgroundcolor','white');

Edit_SP_01 = uicontrol('Style', 'edit',...
    'String', '50',...
    'parent',Grp_01,...
    'Position', [60 43 40 15],...
    'Enable','on',...
    'BackgroundColor',Color_02,...
    'Callback', 'Function_Validate_Set_Point_1');

Button_SP_01 =uicontrol('Style', 'pushbutton',...
    'String', 'Accept',...
    'parent',Grp_01,...
    'Position', [105 43 45 17],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Validate_Set_Point_1');

u2 = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Manual Control',...
    'pos',[4 25 100 15],...
    'tag','Radio_2',...
    'parent',Grp_01,...
    'HandleVisibility','off');

Edit_01 = uicontrol('Style', 'edit',...
    'String', '0',...
    'parent',Grp_01,...
    'Position', [25 5 40 15],...
    'Enable','off',...
    'BackgroundColor',Color_02);

Label_06 =uicontrol('Style', 'text',...
    'String', 'ml/h',...
    'parent',Grp_01,...
    'Position', [65 5 24 15],...
    'Enable','off',...
    'HorizontalAlignment','left',...
    'backgroundcolor','white');

Button_01 =uicontrol('Style', 'pushbutton',...
    'String', 'Accept',...
    'parent',Grp_01,...
    'Position', [90 5 45 17],...
    'Enable','off',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Validate_INF_Rate_1');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create the button group.(Syringe Pump 2)%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Grp_02 = uibuttongroup('visible','on',...
    'backgroundcolor','white',...
    'Title', 'Syringe - 2',...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'Parent',Grp_Controllers,...
    'Units', 'points',...
    'Position',[132 2 120 80],...
    'SelectionChangeFcn','SelectionChangeFcn_Pump_2');


% Create three radio buttons in the button group.
u4 = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Monitoring',...
    'value',2,...
    'tag','Radio_1',...
    'pos',[4 75 100 15],...
    'parent',Grp_02,...
    'HandleVisibility','off');

u6 = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Automatic Control',...
    'pos',[4 60 110 15],...
    'tag','Radio_3',...
    'parent',Grp_02,...
    'HandleVisibility','off');

Label =uicontrol('Style', 'text',...
    'String', 'Set Point',...
    'parent',Grp_02,...
    'Position', [15 43 50 15],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'backgroundcolor','white');

Edit_SP_02 = uicontrol('Style', 'edit',...
    'String', '50',...
    'parent',Grp_02,...
    'Position', [60 43 40 15],...
    'Enable','on',...
    'BackgroundColor',Color_02,...
    'Callback', 'Function_Validate_Set_Point_2');

Button_SP_02 =uicontrol('Style', 'pushbutton',...
    'String', 'Accept',...
    'parent',Grp_02,...
    'Position', [105 43 45 17],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Validate_Set_Point_2');

u5 = uicontrol('Style','Radio',...
    'backgroundcolor', 'white',...
    'String','Manual Control',...
    'pos',[4 25 100 15],...
    'tag','Radio_2',...
    'parent',Grp_02,...
    'HandleVisibility','off');

Edit_02 = uicontrol('Style', 'edit',...
    'String', '0',...
    'parent',Grp_02,...
    'Position', [25 5 40 15],...
    'Enable','off',...
    'BackgroundColor',Color_02);

Label_09 =uicontrol('Style', 'text',...
    'String', 'ml/h',...
    'parent',Grp_02,...
    'Position', [65 5 24 15],...
    'Enable','off',...
    'HorizontalAlignment','left',...
    'backgroundcolor','white');

Button_02 =uicontrol('Style', 'pushbutton',...
    'String', 'Accept',...
    'parent',Grp_02,...
    'Enable','off',...
    'Position', [90 5 45 17],...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Validate_INF_Rate_2');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create the button group.(Syringe Pump 3)%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Grp_03 = uibuttongroup('visible','on',...
    'backgroundcolor','white',...
    'Title', 'Syringe - 3',...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'Parent',Grp_Controllers,...
    'Units', 'points',...
    'Position',[260 2 120 80],....
    'SelectionChangeFcn','SelectionChangeFcn_Pump_3');

% Create three radio buttons in the button group.
u4_N = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Monitoring',...
    'value',1,...
    'tag','Radio_1',...
    'pos',[4 75 100 15],...
    'parent',Grp_03,...
    'HandleVisibility','off');
u5_N = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Manual Control',...
    'pos',[4 25 100 15],...
    'tag','Radio_2',...
    'parent',Grp_03,...
    'HandleVisibility','off');
u6_N = uicontrol('Style','Radio',...
    'backgroundcolor','white',...
    'String','Automatic Control',...
    'pos',[4 60 110 15],...
    'tag','Radio_3',...
    'parent',Grp_03,...
    'HandleVisibility','off');

Label =uicontrol('Style', 'text',...
    'String', 'Set Point',...
    'parent',Grp_03,...
    'Position', [15 43 50 15],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'backgroundcolor','white');

Edit_SP_03 = uicontrol('Style', 'edit',...
    'String', '50',...
    'parent',Grp_03,...
    'Position', [60 43 40 15],...
    'Enable','on',...
    'BackgroundColor',Color_02,...
    'Callback', 'Function_Validate_Set_Point_3');

Button_SP_03 =uicontrol('Style', 'pushbutton',...
    'String', 'Accept',...
    'parent',Grp_03,...
    'Position', [105 43 45 17],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Validate_Set_Point_3');

Edit_02_N = uicontrol('Style', 'edit',...
    'String', '0',...
    'parent',Grp_03,...
    'Position', [25 5 40 15],...
    'Enable','off',...
    'BackgroundColor',Color_02);

Label_09_N =uicontrol('Style', 'text',...
    'String', 'ml/h',...
    'parent',Grp_03,...
    'Position', [65 5 24 15],...
    'Enable','off',...
    'HorizontalAlignment','left',...
    'backgroundcolor','white');

Button_02_N =uicontrol('Style', 'pushbutton',...
    'String', 'Accept',...
    'parent',Grp_03,...
    'Position', [90 5 45 17],...
    'Enable','off',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Validate_INF_Rate_3');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Button_Start =uicontrol('Style', 'pushbutton',...
    'String', 'Start',...
    'FontSize', 10,...
    'FontWeight', 'bold',...
    'Position', [540 560 55 25],...
    'HorizontalAlignment','left',...
    'tag','Bt_Start',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Start');

Button_Stop =uicontrol('Style', 'pushbutton',...
    'String', 'Stop',...
    'FontSize', 10,...
    'FontWeight', 'bold',...
    'Position', [605 560 55 25],...
    'Enable','off',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Stop');



Grp_05 = uibuttongroup('visible','on',...
    'backgroundcolor',get(gcf,'color'),...
    'Title', 'Syringe Pumps',...
    'FontSize', 10,...
    'FontWeight', 'bold',...
    'Units','points',...
    'Position',[5 20 490 110]);

Grp_06 = uibuttongroup('visible','on',...
    'backgroundcolor',get(gcf,'color'),...
    'Title', 'BIS Group',...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'Units','points',...
    'Position',[5 235 490 100]);

Ch_1 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','BIS',...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'value',1,...
    'tag','Check_1',...
    'pos',[10 95 100 15],...
    'parent',Grp_06,...
    'HandleVisibility','off',...
    'Callback', 'Refresh_Plot_1');
Ch_1A = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','BIS Marker',...
    'FontSize', 8,...
    'value',1,...
    'pos',[25 80 90 15],...
    'parent',Grp_06,...
    'HandleVisibility','off',...
    'Callback', 'Refresh_Plot_1');
Ch_1B = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Marker Text',...
    'FontSize', 8,...
    'value',1,...
    'pos',[25 66 90 15],...
    'parent',Grp_06,...
    'HandleVisibility','off',...
    'Callback', 'Refresh_Plot_1');


Ch_2 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','BIS-EMG (dB)',...
    'FontWeight', 'bold',...
    'ForegroundColor','r',...   
    'value',1,...
    'tag','Check_2',...
    'pos',[10 45 100 15],...
    'parent',Grp_06,...
    'HandleVisibility','off',...
    'Callback', 'Refresh_Plot_1');
Ch_3 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','BIS-SQI (%)',...
    'value',1,...
    'FontWeight', 'bold',...
    'ForegroundColor','m',...
    'tag','Check_3',...
    'pos',[10 25 100 15],...
    'parent',Grp_06,...
    'HandleVisibility','off',...
    'Callback', 'Refresh_Plot_1');
Ch_4 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Heart Rate',...
    'value',1,...
    'FontWeight', 'bold',...
    'ForegroundColor',Color_03,...
    'tag','Check_4',...
    'pos',[10 5 100 15],...
    'parent',Grp_06,...
    'HandleVisibility','off',...
    'Callback', 'Refresh_Plot_1');

Label_12 =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_06,...
    'Position', [120 97 75 16],...
    'tag','BIS',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_13 =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_06,...
    'Position', [120 47 75 16],...
    'tag','BIS_EMG',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor','r',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_14 =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_06,...
    'Position', [120 27 75 16],...
    'tag','BIS_SQI',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor','m',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_15 =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_06,...
    'Position', [120 7 75 16],...
    'tag','HR',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor', Color_03,...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Grp_07 = uibuttongroup('visible','on',...
    'backgroundcolor',get(gcf,'color'),...
    'Title', 'NMT Group',...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'Units','points',...
    'Position',[5 133 490 100]);

Ch_5 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','T1 (%)',...
    'value',1,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'tag','Check_5',...
    'pos',[10 90 60 15],...
    'parent',Grp_07,...
    'HandleVisibility','off',...
    'Callback', 'Refresh_Plot_1');

Ch_6 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Tratio (%)',...
    'value',1,...
    'FontWeight', 'bold',...
    'ForegroundColor','r',...
    'tag','Check_6',...
    'pos',[10 45 75 15],...
    'parent',Grp_07,...
    'HandleVisibility','off',...
    'Callback', 'Refresh_Plot_1');

Label_16 =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_07,...
    'Position', [30 70 75 16],...
    'tag','T1',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_17 =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_07,...
    'Position', [30 25 75 16],...
    'tag','Tratio',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor','r',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Grp_08 = uibuttongroup('visible','on',...
    'backgroundcolor','w',...
    'BorderType','line',...
    'HighlightColor','k',...
    'parent',Grp_07,...
    'Units','points',...
    'Position',[83 14 56 64]);

Bar_T1 = uipanel('visible','on',...
    'backgroundcolor','b',...
    'BorderType','line',...
    'HighlightColor','k',...
    'tag','T1_Bar',...
    'parent',Grp_08,...
    'Position',[0.022 0 .22 1]);

Bar_T2 = uipanel('visible','on',...
    'backgroundcolor','b',...
    'BorderType','line',...
    'HighlightColor','k',...
    'tag','T2_Bar',...
    'parent',Grp_08,...
    'Position',[0.264 0 .22 1]);

Bar_T3 = uipanel('visible','on',...
    'backgroundcolor','b',...
    'BorderType','line',...
    'HighlightColor','k',...
    'tag','T3_Bar',...
    'parent',Grp_08,...
    'Position',[0.508 0 .22 1]);

Bar_T4 = uipanel('visible','on',...
    'backgroundcolor','b',...
    'BorderType','line',...
    'HighlightColor','k',...
    'tag','T4_Bar',...
    'parent',Grp_08,...
    'Position',[0.752 0 .22 1]);

Label_18 =uicontrol('Style', 'text',...
    'String', 'T1',...
    'parent',Grp_07,...
    'Position', [114 3 20 14],...
    'FontSize', 9,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_19 =uicontrol('Style', 'text',...
    'String', 'T2',...
    'parent',Grp_07,...
    'Position', [133 3 20 14],...
    'FontSize', 9,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_20 =uicontrol('Style', 'text',...
    'String', 'T3',...
    'parent',Grp_07,...
    'Position', [150 3 20 14],...
    'FontSize', 9,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));


Label_21 =uicontrol('Style', 'text',...
    'String', 'T4',...
    'parent',Grp_07,...
    'Position', [168 3 20 14],...
    'FontSize', 9,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_22 =uicontrol('Style', 'text',...
    'String', '0 -',...
    'parent',Grp_07,...
    'Position', [96 17 14 13],...
    'FontSize', 9,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','right',...
    'backgroundcolor',get(gcf,'color'));

Label_23 =uicontrol('Style', 'text',...
    'String', '50 -',...
    'parent',Grp_07,...
    'Position', [86 58.5 25 12],...
    'FontSize', 9,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','right',...
    'backgroundcolor',get(gcf,'color'));

Label_24 =uicontrol('Style', 'text',...
    'String', '100 -',...
    'parent',Grp_07,...
    'Position', [81 100 30 14],...
    'FontSize', 9,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','right',...
    'backgroundcolor',get(gcf,'color'));

Label_25 =uicontrol('Style', 'text',...
    'String', '%',...
    'parent',Grp_07,...
    'Position', [120 110 30 14],...
    'FontSize', 9,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','right',...
    'backgroundcolor',get(gcf,'color'));

Ch_7 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Pump -1 (ml/h):',...
    'value',1,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'tag','Check_7',...
    'pos',[10 105 115 15],...
    'parent',Grp_05,...
    'HandleVisibility','off');
Ch_8 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Pump -2 (ml/h):',...
    'value',1,...
    'FontWeight', 'bold',...
    'ForegroundColor','r',...
    'tag','Check_8',...
    'pos',[10 65 115 14],...
    'parent',Grp_05,...
    'HandleVisibility','off');

Label_26 =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_05,...
    'Position', [130 107 55 16],...
    'tag','Pump_1',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor','b',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_26A =uicontrol('Style', 'text',...
    'String', 'Controller-1:',...
    'parent',Grp_05,...
    'Position', [45 90 140 14],...
    'tag','Controller_1',...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Limitter_1 = uipanel('visible','on',...
    'backgroundcolor','g',...
    'BorderType','line',...
    'HighlightColor','g',...
    'parent',Grp_05,...
    'Position',[0.02 0.68 0.22 0.015]);


Label_26a =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_05,...
    'Position', [120 90 80 14],...
    'tag','Controller_1',...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_27 =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_05,...
    'Position', [130 67 55 16],...
    'tag','Pump_2',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor','r',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_27A =uicontrol('Style', 'text',...
    'String', 'Controller-2:',...
    'parent',Grp_05,...
    'Position', [45 48 140 14],...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_27a =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_05,...
    'Position', [120 48 80 14],...
    'tag','Controller_2',...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Limitter_2 = uipanel('visible','on',...
    'backgroundcolor','g',...
    'BorderType','line',...
    'HighlightColor','g',...
    'parent',Grp_05,...
    'Position',[0.02 0.35 0.22 0.015]);

Ch_9 = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Pump -3 (ml/h):',...
    'value',1,...
    'FontWeight', 'bold',...
    'ForegroundColor','m',...
    'tag','Check_8',...
    'pos',[10 24 115 14],...
    'parent',Grp_05,...
    'HandleVisibility','off');

Label_27C =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_05,...
    'Position', [130 26 55 16],...
    'tag','Pump_2',...
    'FontSize', 12,...
    'FontWeight', 'bold',...
    'ForegroundColor','m',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_27D =uicontrol('Style', 'text',...
    'String', 'Controller-3:',...
    'parent',Grp_05,...
    'Position', [45 07 140 14],...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Label_27E =uicontrol('Style', 'text',...
    'String', '0',...
    'parent',Grp_05,...
    'Position', [120 07 80 14],...
    'tag','Controller_3',...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Lb_Ymax = uicontrol('Style', 'text',...
    'String', 'Ymax:',...
    'parent',Grp_05,...
    'Position', [230 115 34 14],...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
Ed_Ymax = uicontrol('Style', 'edit',...
    'String', '1200',...
    'parent',Grp_05,...
    'Position', [265 117 30 15],...
    'Enable','on',...
    'BackgroundColor',Color_02);

Lb_Ymin = uicontrol('Style', 'text',...
    'String', 'Ymin:',...
    'parent',Grp_05,...
    'Position', [305 115 34 14],...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
Ed_Ymin = uicontrol('Style', 'edit',...
    'String', '0',...
    'parent',Grp_05,...
    'Position', [335 117 30 15],...
    'Enable','on',...
    'BackgroundColor',Color_02);
Bt_YLim =uicontrol('Style', 'pushbutton',...
    'String', 'Set',...
    'FontSize', 8,...
    'Position', [370 116 50 15],...
    'Enable','on',...
    'parent',Grp_05,...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Set_YLim');


Plot_1 = axes('parent',Grp_06,'Units','points','position',[173 14 300 73],...
    'FontSize', 8, 'tag','PLOT_1');
box on;
grid on;
XLb_1 = uicontrol('Style', 'text',...
    'String', 'Time(min)',...
    'parent',Grp_06,...
    'Position', [400 2 50 14],...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
%ylabel('%')
xlim([0 15])
ylim([0 105])
hold on

Plot_2 = axes('parent',Grp_07,'Units','points','position',[173 14 300 73],...
    'FontSize', 8, 'tag','PLOT_2');
box on;
grid on;
XLb_2 = uicontrol('Style', 'text',...
    'String', 'Time(min)',...
    'parent',Grp_07,...
    'Position', [400 2 50 14],...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
%xlabel('Time (min)')
%ylabel('%')
xlim([0 15])
ylim([0 105])
hold on

Plot_3 = axes('parent',Grp_05,'Units','points','position',[173 14 300 70],...
    'FontSize', 8, 'tag','PLOT_3');
box on;
grid on;
XLb_3 = uicontrol('Style', 'text',...
    'String', 'Time(min)',...
    'parent',Grp_05,...
    'Position', [400 2 50 14],...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
xlabel('Time (min)')
%ylabel('%')
xlim([0 15])
ylim([0 1200])
hold on
zoom on

Button_Left =uicontrol('Style', 'pushbutton',...
    'String', '<< AXES',...
    'FontSize', 8,...
    'Position', [270 4 50 15],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Left_AXES');

Button_Right =uicontrol('Style', 'pushbutton',...
    'String', 'AXES >>',...
    'FontSize', 8,...
    'Position', [340 4 50 15],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Right_AXES');

Button_Clear =uicontrol('Style', 'pushbutton',...
    'String', 'Clear',...
    'FontSize', 8,...
    'Position', [410 4 50 15],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Clear_AXES');

Button_Return =uicontrol('Style', 'pushbutton',...
    'String', 'Return',...
    'FontSize', 8,...
    'Position', [470 4 50 15],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Return_AXES');

uicontrol('Style', 'pushbutton',...
    'String', 'Axes Lim',...
    'FontSize', 8,...
    'Position', [530 4 55 15],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_ACA(30)');

% This timer defines the sampling time
Timer_1 = timer('TimerFcn','Timer_1_Function', 'Period', Sampling_Time,'ExecutionMode','fixedRate');

Timer_Pump_1 = timer('TimerFcn','Timer_Pump_1_Function', 'Period', Sampling_Time_Pump1,'ExecutionMode','fixedRate');

Timer_Pump_2 = timer('TimerFcn','Timer_Pump_2_Function', 'Period', Sampling_Time_Pump2,'ExecutionMode','fixedRate');

Timer_Pump_3 = timer('TimerFcn','Timer_Pump_3_Function', 'Period', Sampling_Time_Pump3,'ExecutionMode','fixedRate');

Timer_Simulator = timer('TimerFcn','Timer_Simulator_Function', 'Period', 0.010,'ExecutionMode','fixedRate');


%zoom on %off
 ZOOM_1 = zoom(Plot_1);

    set(ZOOM_1,'ActionPreCallback','Function_Zoom_1(1)');
    set(ZOOM_1,'ActionPostCallback','Function_Zoom_1(2)');
    set(ZOOM_1,'Enable','on');

