%%%%%%%%%%%%%   Discret_NMB_Space_State_Model.m   %%%%%%%%%%%%%%%%%%%%
% 
% Input:
% 
% Ts: Sampling Time

% Luis Paz (with help of Juliana ALmeida and Margarita Silva)
% 2011_01_06
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Ym State] = Discret_NMB_Space_State_Model(U, X_0, Model)
global A_Dcrt B_Dcrt C_Dcrt Theta C50 GAMMA;
if Model == 1
    % Reduced Model
    State=A_Dcrt*X_0+B_Dcrt*U;
    yl=C_Dcrt*State;
    yl(yl<=0)=1e-4;
    Ym = (100*C50^GAMMA)./(C50^GAMMA+yl.^GAMMA);
    Ym = min(100,max(0,Ym));
    
end
if Model == 2
    % PK-PD Model
    State = A_Dcrt*X_0+B_Dcrt*U;
    yl = C_Dcrt*State;
    yl(yl<=0)=1e-4;
    Ym = (100*Theta(7)^Theta(8))/(Theta(7)^Theta(8)+yl.^Theta(8));
    Ym = min(100,max(0,Ym));
end
end
