%%% This function defines the operation mode (Real or Simulation)           %%%
%%% Luis Alberto Paz Surez                                                 %%%
%%% 2010-12-22                                                              %%%

function Function_Bt_SIM(Button)
global Fig_Simulator Master Ref_NMB Manual_C Noise_Rate Flag_Filter;
global Timer_Simulator Flag_Tunning Cont_TTunning_1 Cont_TTunning_2;
global Control_1 Index;
switch Button
    case 1
        stop(Timer_Simulator)
        %%% Change in Master control
        if (get(findobj('tag','RB_Auto'),'Value') == get(findobj('tag','RB_Auto'),'Max'))
            set(findobj('tag','BEdit_Manual'),'Enable','inactive')
            set(findobj('tag','Bt_Manual'),'Enable','off')
            Master = 1;
            annotation(Fig_Simulator,'arrow',[0.15 0.15],[0.25 0.42],'LineWidth',2,'Color',get(gcf,'color'));
            annotation(Fig_Simulator,'arrow',[0.2 0.2],[0.32 0.42],'LineWidth',2,'Color','k');
            annotation(Fig_Simulator,'line',[0.27 0.2],[0.32 0.32],'LineWidth',2,'Color','k');
        else
            set(findobj('tag','BEdit_Manual'),'Enable','on')
            set(findobj('tag','Bt_Manual'),'Enable','on')
            Master = 0;
            annotation(Fig_Simulator,'arrow',[0.15 0.15],[0.25 0.42],'LineWidth',2,'Color','k');
            annotation(Fig_Simulator,'arrow',[0.2 0.2],[0.32 0.42],'LineWidth',2,'Color',get(gcf,'color'));
            annotation(Fig_Simulator,'line',[0.27 0.2],[0.32 0.32],'LineWidth',2,'Color',get(gcf,'color'));
            Var = str2double(get(findobj('tag','BEdit_Manual'),'string'));
            if (isnan(Var) || (Var < 0)||(Var > 1200))
                errordlg('The control value is not valid', 'Control Value Error')
            else
                Manual_C = Var;
            end

        end
        Var = strcmp(get(findobj('tag','Bt_Start'),'Enable'),'off');
        if ( Var == 1)
            start(Timer_Simulator)
        end
    case 2
        %%% Button to set the control value (Master Control "Apply")
        Var = str2double(get(findobj('tag','BEdit_Manual'),'string'));
        if (isnan(Var) || (Var < 0)||(Var > 1200))
            errordlg('The control value is not valid', 'Control Value Error')
        else
            Manual_C = Var;
        end
        
    case 3
        %%% Button Auto Tunning
        Master = 0;
        Flag_Tunning = 1;
        Cont_TTunning_1 = 0;
        Cont_TTunning_2 = 0;
        %Manual_C = 8;
        Manual_C = Control_1(Index);
        
    case 4
        %%%%%% popup menu to define the model
        Model_Class = get(findobj('tag','PpM_Model'),'Value');
        switch Model_Class
            case 1
                set(findobj('tag','Lb_Model'),'String','NMB Rced. MODEL')
                set(findobj('tag','PpM_Case_Model'),'String','1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31|32|33|34|35|36|37|38|39|40|41|42|43|44|45|46|47|48|49|50|51|52|53|54|55|56|57|58|59|60')
            case 2
                set(findobj('tag','Lb_Model'),'String','NMB PK/PD MODEL')
                set(findobj('tag','PpM_Case_Model'),'String','1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31|32|33|34|35|36|37|38|39|40|41|42|43|44|45|46|47|48|49|50|51|52|53|54|55|56|57|58|59|60|61|62|63|64|65|66|67|68|69|70|71|72|73|74|75|76|77|78|79|80|81|82|83|84|85|86|87|88|89|90|91|92|93|94|95|96|97|98|99|100');            
            case 3
                set(findobj('tag','Lb_Model'),'String','DATA FILE')
        end
        
    case 5
        %%%%%% popup menu to define the controller
        Control_Class = get(findobj('tag','PpM_Control'),'Value');
        switch Control_Class
            case 1
                set(findobj('tag','Lb_Controller'),'String','Proportional')
            case 2
                set(findobj('tag','Lb_Controller'),'String','PID-Fixo')
            case 3
                set(findobj('tag','Lb_Controller'),'String','Auto-PID-T50')
            case 4
                set(findobj('tag','Lb_Controller'),'String','Auto-PID-PCA')
                
        end
    case 6
        %%%% Button to defene the Set Point
        Var = str2double(get(findobj('tag','BEdit_SP_NMB'),'string'));    % Referencia
        if (isnan(Var) || (Var < 0)||(Var > 50))
            errordlg('The Set Point Value is not valid', 'Set Point Value Error')
        else
            Ref_NMB = Var;
        end

    case 7
        %%% Button to define level of noise
        Var = str2double(get(findobj('tag','BEdit_Noise'),'string'));
        if (isnan(Var) || (Var < 0)||(Var > 2))
            errordlg('The Noise Value is not valid', 'Noise Value Error')
        else
            Noise_Rate = Var;
        end

        
    case 8
        %%% Define the class of filter
        
    case 9
        %%% Enable or desable the filter opcion
        if (get(findobj('tag','Ch_Filter'),'value') ==(get(findobj('tag','Ch_Filter'),'max')))
            Flag_Filter = 1;
            display('activado filtro')
            
        else
            Flag_Filter = 0;
        end
        

end


    