%%% This function defines the Simulator figure                              %%%
%%% Luis Alberto Paz Surez                                                 %%%
%%% 2010-12-22                                                              %%%

function Function_Fig_Simulator()
global RB_Real_Time RB_Simulator hpop_Step Fig_Simulator;
global hpop_Real_Case Master Manual_C Noise_Rate;
global Edit_Pump_1 Edit_NMB DefFigSim Color_01 Color_02;
Master = 1; Manual_C = 10; Noise_Rate = 0;
Fig_Simulator = figure( ...
    'PaperUnits','points', ...
    'Position',DefFigSim, ...
    'KeyPressFcn', 'figure(gcf)', ...
    'Color',Color_01,...
    'doublebuffer','on',...
    'CloseRequestFcn','my_closereq_01(2);',...
    'resize','off',...
    'NumberTitle','off',...
    'menubar','none',...
    'windowstyle','normal',...
    'Name', 'DATEX Variables Simulator');


Button_Auto_T =uicontrol('Style', 'pushbutton',...
    'String', 'Auto Tunning',...
    'FontSize', 8,...
    'Position', [320 7 70 18],...
    'Enable','on',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Bt_SIM(3)');

Grp_Master = uibuttongroup('visible','on',...
    'Title', 'Master Ctrl',...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'backgroundcolor',get(gcf,'color'),...
    'BorderType','line',...
    'HighlightColor','k',...
    'Units','points',...
    'Position',[1 3 76 40],...
    'SelectionChangeFcn', 'Function_Bt_SIM(1)');

RB_Manual_N = uicontrol('Style','Radio',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Manual',...
    'value',0,...
    'parent',Grp_Master,...
    'tag','RB_Manual',...
    'pos',[2 4 60 15],...
    'HandleVisibility','off');


RB_Auto_N = uicontrol('Style','Radio',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Auto',...
    'value',1,...
    'parent',Grp_Master,...
    'tag','RB_Auto',...
    'pos',[57 4 44 15],...
    'HandleVisibility','on');


Edit_Manual = uicontrol('Style', 'edit',...
    'String', '10',...
    'Position', [10 20 40 15],...
    'FontWeight', 'bold',...
    'Enable','inactive',...
    'parent',Grp_Master,...
    'tag','BEdit_Manual',...
    'BackgroundColor',Color_02);
Button_Manual =uicontrol('Style', 'pushbutton',...
    'String', 'Apply',...
    'FontSize', 8,...
    'Position', [57 22 40 15],...
    'Enable','off',...
    'parent',Grp_Master,...
    'tag','Bt_Manual',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Bt_SIM(2)');


Grp_Model = uibuttongroup('visible','on',...
    'backgroundcolor','w',...
    'BorderType','line',...
    'HighlightColor','k',...
    'Units','points',...
    'Position',[80 67 70 50]);
hpop_Model = uicontrol('Style', 'popup',...
    'String', 'MR-NMB|PK/PD-NMB|Data File',...
    'Position', [8 23 78 15],...
    'Value',1,...
    'parent',Grp_Model,...
    'tag','PpM_Model',...
    'Callback', 'Function_Bt_SIM(4)');
Grp_Noise = uibuttongroup('visible','on',...
    'backgroundcolor',get(gcf,'color'),...
    'BorderType','line',...
    'HighlightColor','k',...
    'Units','points',...
    'Position',[169 74 55 40]);

Lb_Sim_Model_1 =uicontrol('Style', 'text',...
    'String', 'MODEL ',...
    'Position', [20 50 60 14],...
    'parent',Grp_Model,...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','center',...
    'backgroundcolor','w');
Lb_Sim_Noise =uicontrol('Style', 'text',...
    'String', 'Noise ',...
    'Position', [20 35 40 14],...
    'parent',Grp_Noise,...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','center',...
    'backgroundcolor',get(gcf,'color'));

Lb_Sim_Noise_1 =uicontrol('Style', 'text',...
    'String', '(%)',...
    'Position', [3 20 20 14],...
    'parent',Grp_Noise,...
    'FontWeight', 'normal',...
    'ForegroundColor','k',...
    'HorizontalAlignment','center',...
    'backgroundcolor',get(gcf,'color'));
Button_SIM_Noise =uicontrol('Style', 'pushbutton',...
    'String', 'Apply',...
    'FontSize', 7.5,...
    'Position', [25 3 40 15],...
    'Enable','on',...
    'parent',Grp_Noise,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Bt_SIM(7)');

Edit_Noise = uicontrol('Style', 'edit',...
    'String', '0',...
    'Position', [25 20 40 15],...
    'FontWeight', 'normal',...
    'parent',Grp_Noise,...
    'Enable','on',...
    'tag','BEdit_Noise',...
    'BackgroundColor',Color_02);
    annotation(Fig_Simulator,'arrow',[0.5 0.56],[0.54 0.54]);
    annotation(Fig_Simulator,'arrow',[0.5 0.56],[0.64 0.64]);



Grp_Control = uibuttongroup('visible','on',...
    'backgroundcolor','w',...
    'BorderType','line',...
    'HighlightColor','k',...
    'Units','points',...
    'Position',[80 20 70 35]);
Lb_Sim_Control_N =uicontrol('Style', 'text',...
    'String', 'Controller',...
    'Position', [10 29 80 14],...
    'parent',Grp_Control,...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','center',...
    'backgroundcolor','w');
hpop_Control = uicontrol('Style', 'popup',...
    'String', 'P|PID-Fixo|PID-T50|PID-PCA',...
    'Position', [13 13 70 15],...
    'parent',Grp_Control,...
    'Value',1,...
    'tag','PpM_Control',...
    'Callback', 'Function_Bt_SIM(5)');

Grp_Filter = uibuttongroup('visible','on',...
    'backgroundcolor',get(gcf,'color'),...
    'BorderType','line',...
    'HighlightColor','k',...
    'Units','points',...
    'Position',[169 24 75 40]);
Lb_Sim_Filter_N =uicontrol('Style', 'text',...
    'String', 'Filter',...
    'Position', [20 37 50 14],...
    'parent',Grp_Filter,...
    'FontWeight', 'bold',...
    'HorizontalAlignment','center',...
    'backgroundcolor',get(gcf,'color'));

hpop_Filter = uicontrol('Style', 'popup',...
    'String', 'Filter-1|Filter-2|Filter-3|Filter-4|Filter-5|Filter-6',...
    'Position', [28 8 58 15],...
    'Value',1,...
    'tag','PpM_Filter',...
    'parent',Grp_Filter,...
    'Callback', 'Function_Bt_SIM(8)');

Ch_Filter_N = uicontrol('Style','checkbox',...
    'backgroundcolor',get(gcf,'color'),...
    'String','Enable',...
    'FontWeight', 'normal',...
    'value',0,...
    'tag','Ch_Filter',...
    'pos',[3 25 60 15],...
    'parent',Grp_Filter,...
    'Callback', 'Function_Bt_SIM(9)');
Button_Filter_Setup =uicontrol('Style', 'pushbutton',...
    'String', 'Setup',...
    'FontSize', 7.5,...
    'Position', [57 25 40 14],...
    'Enable','on',...
    'parent',Grp_Filter,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Bt_SIM(10)');


Grp_Set_Point = uibuttongroup('visible','on',...
    'Title', 'Set Point',...
    'FontSize', 8,...
    'FontWeight', 'bold',...
    'backgroundcolor',get(gcf,'color'),...
    'BorderType','line',...
    'HighlightColor','k',...
    'Units','points',...
    'Position',[200 120 95 37]);

Button_SIM_Set =uicontrol('Style', 'pushbutton',...
    'String', 'Apply',...
    'FontSize', 7.5,...
    'Position', [80 12 40 14],...
    'Enable','on',...
    'parent',Grp_Set_Point,...
    'BackgroundColor',get(gcf,'color'),...
    'Callback', 'Function_Bt_SIM(6)');

Lb_SP_BIS = uicontrol('Style', 'text',...
    'String', 'BIS:',...
    'Position', [5 5 25 11],...
    'parent',Grp_Set_Point,...
    'ForegroundColor','k',...
    'HorizontalAlignment','right',...
    'backgroundcolor',get(gcf,'color'));
Lb_SP_NMB = uicontrol('Style', 'text',...
    'String', 'NMB:',...
    'Position', [5 20 25 11],...
    'parent',Grp_Set_Point,...
    'ForegroundColor','k',...
    'HorizontalAlignment','right',...
    'backgroundcolor',get(gcf,'color'));
Edit_SP_BIS = uicontrol('Style', 'edit',...
    'String', '20',...
    'Position', [35 3 42 15],...
    'FontWeight', 'normal',...
    'parent',Grp_Set_Point,...
    'Enable','on',...
    'tag','BEdit_SP_BIS',...
    'BackgroundColor',Color_02);
Edit_SP_NMB = uicontrol('Style', 'edit',...
    'String', '10',...
    'Position', [35 20 42 15],...
    'FontWeight', 'normal',...
    'parent',Grp_Set_Point,...
    'Enable','on',...
    'tag','BEdit_SP_NMB',...
    'BackgroundColor',Color_02);

    annotation(Fig_Simulator,'line',[0.87 0.87],[0.42 0.32],'LineWidth',2);
    annotation(Fig_Simulator,'arrow',[0.87 0.81],[0.32 0.32],'LineWidth',2);
    annotation(Fig_Simulator,'arrow',[0.56 0.5],[0.32 0.32],'LineWidth',2);
    annotation(Fig_Simulator,'arrow',[0.2 0.2],[0.32 0.42],'LineWidth',2);
    annotation(Fig_Simulator,'line',[0.27 0.2],[0.32 0.32],'LineWidth',2);


hpop_Set_Control = uicontrol('Style', 'popup',...
    'String','1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31|32|33|34|35|36|37|38|39|40|41|42|43|44|45|46|47|48|49|50|51|52|53|54|55|56|57|58|59|60|61|62|63|64|65|66|67|68|69|70|71|72|73|74|75|76|77|78|79|80|81|82|83|84|85|86|87|88|89|90|91|92|93|94|95|96|97|98|99|100',...
    'Position', [270 9 40 15],...
    'Value',1,...
    'tag','PpM_Case_Control',...
    'Callback', 'Function_Bt_SIM(5)');

Lb_Set_Control =uicontrol('Style', 'text',...
    'String', 'Controller Paramet. Set:',...
    'Position', [150 4 120 14],...
    'FontWeight', 'normal',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

    
Lb_Sim_Pump_1 =uicontrol('Style', 'text',...
    'String', 'Pump 1:',...
    'Position', [3 135 40 14],...
    'FontWeight', 'normal',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
Edit_Pump_1 = uicontrol('Style', 'edit',...
    'String', '0',...
    'Position', [43 135 40 15],...
    'FontWeight', 'bold',...
    'Enable','inactive',...
    'HorizontalAlignment','right',...
    'tag','BEdit_Pump1',...
    'BackgroundColor',Color_02);
    annotation(Fig_Simulator,'arrow',[0.2 0.27],[0.67 0.67]);

Lb_Sim_Pump_2 =uicontrol('Style', 'text',...
    'String', 'Pump 2:',...
    'Position', [3 115 40 14],...
    'FontWeight', 'normal',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
Edit_Pump_2 = uicontrol('Style', 'edit',...
    'String', '0',...
    'Position', [43 115 40 15],...
    'FontWeight', 'bold',...
    'Enable','inactive',...
    'tag','BEdit_Pump2',...
    'HorizontalAlignment','right',...
    'BackgroundColor',Color_02);
    annotation(Fig_Simulator,'arrow',[0.2 0.27],[0.58 0.58]);

Lb_Sim_Pump_3 =uicontrol('Style', 'text',...
    'String', 'Pump 3:',...
    'Position', [3 95 40 14],...
    'FontWeight', 'normal',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
Edit_Pump_3 = uicontrol('Style', 'edit',...
    'String', '0',...
    'Position', [43 95 40 15],...
    'FontWeight', 'bold',...
    'Enable','inactive',...
    'tag','BEdit_Pump3',...
    'HorizontalAlignment','right',...
    'BackgroundColor',Color_02);
    annotation(Fig_Simulator,'arrow',[0.2 0.27],[0.48 0.48]);


hpop_Real_Case = uicontrol('Style', 'popup',...
    'String', '1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31|32|33|34|35|36|37|38|39|40|41|42|43|44|45|46|47|48|49|50|51|52|53|54|55|56|57|58|59|60|',...
    'Position', [110 180 40 15],...
    'Value',1,...
    'tag','PpM_Case_Model',...
    'Callback', 'Function_Bt_SIM(5)');

Lb_Select_Case =uicontrol('Style', 'text',...
    'String', 'Model Paramet. Set:',...
    'Position', [10 175 100 14],...
    'FontWeight', 'normal',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Lb_Input =uicontrol('Style', 'text',...
    'String', 'INPUT',...
    'Position', [10 70 40 17],...
    'FontSize',9,...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Lb_Output =uicontrol('Style', 'text',...
    'String', 'OUTPUT',...
    'Position', [353 70 60 17],...
    'FontSize',9,...
    'FontWeight', 'bold',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));

Lb_Sim_BIS =uicontrol('Style', 'text',...
    'String', 'BIS',...
    'Position', [370 108 40 14],...
    'FontWeight', 'normal',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
Edit_BIS = uicontrol('Style', 'edit',...
    'String', '0',...
    'Position', [325 108 40 15],...
    'FontWeight', 'bold',...
    'Enable','inactive',...
    'tag','BEdit_BIS',...
    'HorizontalAlignment','right',...
    'BackgroundColor',Color_02);
    annotation(Fig_Simulator,'arrow',[0.75 0.81],[0.54 0.54]);
    
Lb_Sim_NMB =uicontrol('Style', 'text',...
    'String', 'NMB',...
    'Position', [370 128 40 14],...
    'FontWeight', 'normal',...
    'ForegroundColor','k',...
    'HorizontalAlignment','left',...
    'backgroundcolor',get(gcf,'color'));
Edit_NMB = uicontrol('Style', 'edit',...
    'String', '0',...
    'Position', [325 128 40 15],...
    'FontWeight', 'bold',...
    'Enable','inactive',...
    'tag','BEdit_NMB',...
    'HorizontalAlignment','right',...
    'BackgroundColor',Color_02);
    annotation(Fig_Simulator,'arrow',[0.75 0.81],[0.64 0.64]);

