%%%%%%%%%%%%%   PID_Controller.m   %%%%%%%%%%%%%%%%%%%%
%
%  
% 
% Outpu:
% 
% Uc: Control action
% Acum: Sum of the integral

% Luis Paz (with help of Juliana ALmeida and Margarita Silva)
% 2011_01_16
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Uc, Acum] = PID_Controller()
global Kc Ti Td Ts E Temp Index; 

Uc = Temp(Index-1) + Kc*E(Index) + Kc*Td*(E(Index) - E(Index-1))/Ts;
Acum = Temp(Index-1) + Kc*Ts*E(Index)/Ti;

if (Uc < 0)
    Uc = 0;
    Acum = Temp(Index-1);    % Avoid saturation of the controller
end
if (Uc >1200)
    Uc = 1200;
    Acum = Temp(Index-1);    % Avoid saturation of the controller
end

end
