function Refresh_Plot_1()
global Plot_1 Plot_2 Color_03 BIS_Marker Marker_Text Point_Marker  Flag_AXES_Shift;
global Ch_1 Ch_1A Ch_1B Ch_2 Ch_3 Ch_4 Ch_5 Ch_6 Time_AXES;


%%% only the next data can be plot  %%%%%%%%%%%
global Time_DATEX_Data BIS_Data BIS_EMG_Data BIS_SQI_Data Heart_Rate_Data T1_Data Tratio_Data;
global BIS_Error BIS_EMG_Error BIS_SQI_Error Heart_Rate_Error T1_Error Tratio_Error;
global BIS_Error_Time BIS_EMG_Error_Time BIS_SQI_Error_Time Heart_Rate_Error_Time T1_Error_Time Tratio_Error_Time;

%%% Set the x axes lim  %%%
if Flag_AXES_Shift == 0
    time = Time_DATEX_Data(length(Time_DATEX_Data))/60;
    X1_LIM = xlim(Plot_1);
    if time > X1_LIM(2)
        X1_LIM(2)= X1_LIM(2) + Time_AXES/3;
        X1_LIM(1)= X1_LIM(1) + Time_AXES/3;
        xlim(Plot_1, X1_LIM);
        xlim(Plot_2, X1_LIM);
    end
end

%%%%% Plot the selected variables  %%%%%%%%%%%
cla(Plot_1);
if (get(Ch_1,'Value') == get(Ch_1,'Max'))
    plot(Plot_1, Time_DATEX_Data/60, BIS_Data, 'b', 'LineWidth',2);
    plot(Plot_1, BIS_Error_Time/60, BIS_Error, '*b');
end

if (get(Ch_2,'Value') == get(Ch_2,'Max'))
    plot(Plot_1, Time_DATEX_Data/60, BIS_EMG_Data, 'r', 'LineWidth',2);
    plot(Plot_1, BIS_EMG_Error_Time/60, BIS_EMG_Error, '*r');
end

if (get(Ch_3,'Value') == get(Ch_3,'Max'))
    plot(Plot_1, Time_DATEX_Data/60, BIS_SQI_Data, 'm', 'LineWidth',2);
    plot(Plot_1, BIS_SQI_Error_Time/60, BIS_SQI_Error, '*m');
end

if (get(Ch_4,'Value') == get(Ch_4,'Max'))
    plot(Plot_1, Time_DATEX_Data/60, Heart_Rate_Data,'Color', Color_03, 'LineWidth',2);
    plot(Plot_1, Heart_Rate_Error_Time/60, Heart_Rate_Error, '*', 'Color',Color_03);
end
%%%% Plot BIS_Marker    %%%%%%%
if (get(Ch_1,'Value') == get(Ch_1,'Max'))
    if (get(Ch_1A,'Value') == get(Ch_1A,'Max'))
        for i = 1:size(BIS_Marker,1)
            switch BIS_Marker(i,3)
                case 1
                    plot(Plot_1, BIS_Marker(i,2)/60, BIS_Marker(i,1), 's','LineWidth',1,'MarkerSize', 10);
                case 2
                    plot(Plot_1, BIS_Marker(i,2)/60, BIS_Marker(i,1), 's','LineWidth',2,'MarkerSize', 10, 'MarkerFaceColor','g');
                case 3
                    plot(Plot_1, BIS_Marker(i,2)/60, BIS_Marker(i,1), 's','LineWidth',2,'MarkerSize', 10, 'MarkerFaceColor','r');
                case 4
                    plot(Plot_1, BIS_Marker(i,2)/60, BIS_Marker(i,1), 's','LineWidth',2,'MarkerSize', 10, 'MarkerFaceColor','y');
            end
        end
    end
    %%%% Plot Marker_Text    %%%%%%%
    if (get(Ch_1B,'Value') == get(Ch_1B,'Max'))
        set(gcf,'CurrentAxes',Plot_1)
        if ~isempty(BIS_Marker)
            for i= 1:size(Marker_Text,2)
                Lim_X_P1 = xlim(Plot_1);
                Lim_Y_P1 = ylim(Plot_1);
                %axes(Plot_1)
                if (BIS_Marker(i,2)/60 >= Lim_X_P1(1)) && (BIS_Marker(i,2)/60 <= Lim_X_P1(2))
                    if (BIS_Marker(i,1) >= Lim_Y_P1(1)) && (BIS_Marker(i,1) <= Lim_Y_P1(2))
                        if mod(i,2) == 1
                            %%%  Plot Note on botton %%%
                            if BIS_Marker(i,1) > (Lim_Y_P1(1) + (Lim_Y_P1(2)- Lim_Y_P1(1))* 0.3)
                                Py_T = Lim_Y_P1(1)+ (Lim_Y_P1(2)- Lim_Y_P1(1))/8;
                            else
                                Py_T = Lim_Y_P1(1)+ (Lim_Y_P1(2)- Lim_Y_P1(1))*6/8;
                            end
                            Px_T = BIS_Marker(i,2)/60 + (Lim_X_P1(2)- Lim_X_P1(1))/75;
                            Px_L = [BIS_Marker(i,2)/60 Px_T];
                            Py_L = [BIS_Marker(i,1) Py_T];
                            text(Px_T, Py_T, Marker_Text{[i]}, 'FontSize',7,'FontWeight','bold', 'EdgeColor','c')
                            line(Px_L,Py_L,'Color','c');
                        else
                            %%%  Plot Note on top %%%
                            if BIS_Marker(i,1) < (Lim_Y_P1(1) + (Lim_Y_P1(2)- Lim_Y_P1(1))* 0.6)
                                Py_T = Lim_Y_P1(1)+ (Lim_Y_P1(2)- Lim_Y_P1(1))*7/8;
                            else
                                Py_T = Lim_Y_P1(1)+ (Lim_Y_P1(2)- Lim_Y_P1(1))*3/8;
                            end
                            Px_T = BIS_Marker(i,2)/60 + (Lim_X_P1(2)- Lim_X_P1(1))/75;
                            Px_L = [BIS_Marker(i,2)/60 Px_T];
                            Py_L = [BIS_Marker(i,1) Py_T];
                            text(Px_T, Py_T, Marker_Text{[i]}, 'FontSize',7,'FontWeight','bold', 'EdgeColor','c')
                            line(Px_L,Py_L,'Color','c');
                        end
                    end
                end
            end
        end
    end
    if ~isempty(Point_Marker)
        plot (Plot_1, Point_Marker(1)/60,Point_Marker(2), 'o', 'LineWidth', 1, 'MarkerSize',12)
    end
end
cla(Plot_2);
if (get(Ch_5,'Value') == get(Ch_5,'Max'))
    plot(Plot_2, Time_DATEX_Data/60, T1_Data, 'b','LineWidth',2);
    plot(Plot_2, T1_Error_Time/60, T1_Error, '*b');
end

if (get(Ch_6,'Value') == get(Ch_6,'Max'))
    plot(Plot_2, Time_DATEX_Data/60, Tratio_Data, 'r','LineWidth',2);
    plot(Plot_2, Tratio_Error_Time/60, Tratio_Error, '*r');
end