%%% This funtion is implementes each sampling time                      %%%
%%% Timer_1_Function has the following actions                          %%%
%%%     1. To Read the message in the three UDP sockects (local port)   %%%
%%%                 (DATEX, PUMP 1 and Pump 2)                          %%%     
%%%     2. To decode the three UDP messages                             %%% 
%%%     3. To Display and plot the main variables                       %%%
%%%     4. In "Automatic" control mode:                                 %%%
%%%             (1) It call the corresponding function to determine the %%%
%%%                 infusion rate value ("Function_Automatic_Control_1")%%%
%%%             (2) It Sends to two UDP sockects (PUMP 1 and Pump 2)    %%%
%%%                 (remote port) the infusion rate value               %%% 
%%% Luis Alberto Paz Surez                                             %%%
%%% 2010-08-17                                                          %%%


function Timer_1_Function()
global Sampling_Time Time_Elapse Time_AXES Flag_AXES_Shift ;
global Plot_1 Plot_2 Color_03 BIS_Marker Marker_Text Point_Marker;
global Init VectorChangePoint VectorTypeChange BIS_Sound BIS_Fs;
global Ch_1 Ch_2 Ch_3 Ch_4 Ch_5 Ch_6;
global Label_12 Label_13 Label_14 Label_15 Label_16 Label_17 Bar_T1 Bar_T2 Bar_T3 Bar_T4;

global DATEX_UDP_Port_Read;
global Pump_1_UDP_Port_Read;
global Pump_1_UDP_Port_Write;
global Pump_2_UDP_Port_Read;
global Pump_2_UDP_Port_Write;
global Pump_3_UDP_Port_Read;
global Pump_3_UDP_Port_Write;

global sockcon_1;

global Sampling_Time_1 Real_Time_1 BIS BIS_EMG BIS_SQI BIS_SupRat Heart_Rate T1 Tratio;
global Stimulus_Mode Pulse_Width T1_abs T2_abs T3_abs T4_abs;



%%% only the next data can be plot  %%%%%%%%%%%
global Time_DATEX_Data BIS_Data BIS_EMG_Data BIS_SQI_Data Heart_Rate_Data T1_Data Tratio_Data;
global BIS_Error BIS_EMG_Error BIS_SQI_Error Heart_Rate_Error T1_Error Tratio_Error;
global BIS_Error_Time BIS_EMG_Error_Time BIS_SQI_Error_Time Heart_Rate_Error_Time T1_Error_Time Tratio_Error_Time;

Time_Elapse = Time_Elapse + Sampling_Time;

%%%%%% get data from DATEX UDP local port %%%%%%%
DATEX_message = Function_UDP_Read(sockcon_1);

%%%%%% Decode and display DATEX message %%%%%%%%%%%%
if length(DATEX_message) > 1
    Decode_DATEX_UDP_message(DATEX_message)
    
    %%%  Save array with the plot variables
    Time_DATEX_Data(length(Time_DATEX_Data) +1) = Time_Elapse;
    %%% Save BIS array    %%%
    if (str2double(BIS)<= 0)
        if (isempty(BIS_Data))
            BIS_Data(1)= 0;
            BIS_Error(1)=0;
            BIS_Error_Time(1)= Time_Elapse;
        else
            BIS_Data(length(BIS_Data) +1) = BIS_Data(length(BIS_Data));
            BIS_Error(length(BIS_Error)+1)= BIS_Data(length(BIS_Data));
            BIS_Error_Time(length(BIS_Error_Time)+1) = Time_Elapse;
        end;
    else
        BIS_Data(length(BIS_Data) +1) = str2double(BIS);
        %%%%   IF case make marker %%%%
        [InfoChangePoint]  = Run_PHAditivo_Bloco(str2double(BIS))
        if ~isempty(InfoChangePoint)
            BIS_Marker(size(BIS_Marker,1)+1,1)= str2double(BIS);
            BIS_Marker(size(BIS_Marker,1),2)= Time_Elapse;
            BIS_Marker(size(BIS_Marker,1),3)= 1;
            BIS_Marker(size(BIS_Marker,1),4)= InfoChangePoint(2);
            
            if (size(Marker_Text,2)== 1) && (isempty(Marker_Text{[1]}))
                Var_Size = 1;
            else
                Var_Size = size(Marker_Text,2) + 1;
            end
            if (InfoChangePoint(2) == 1)
                Marker_Text{[Var_Size]}= 'ASCEND';
            else
                Marker_Text{[Var_Size]}= 'DESCEND';
            end            
            wavplay(BIS_Sound, BIS_Fs)
        end
        
    end;
    %%% Save BIS_EMG array    %%%
    if (str2double(BIS_EMG)< 0)
        if (isempty(BIS_EMG_Data))
            BIS_EMG_Data(1)= 0;
            BIS_EMG_Error(1)=0;
            BIS_EMG_Error_Time(1)= Time_Elapse;
        else
            BIS_EMG_Data(length(BIS_EMG_Data) +1) = BIS_EMG_Data(length(BIS_EMG_Data));
            BIS_EMG_Error(length(BIS_EMG_Error)+1)= BIS_EMG_Data(length(BIS_EMG_Data));
            BIS_EMG_Error_Time(length(BIS_EMG_Error_Time)+1) = Time_Elapse;
        end;
    else
        BIS_EMG_Data(length(BIS_EMG_Data) +1) = str2double(BIS_EMG);
    end;
    %%% Save BIS_SQI array    %%%
    if (str2double(BIS_SQI)< 0)
        if (isempty(BIS_SQI_Data))
            BIS_SQI_Data(1)= 0;
            BIS_SQI_Error(1)=0;
            BIS_SQI_Error_Time(1)= Time_Elapse;
        else
            BIS_SQI_Data(length(BIS_SQI_Data) +1) = BIS_SQI_Data(length(BIS_SQI_Data));
            BIS_SQI_Error(length(BIS_SQI_Error)+1)= BIS_SQI_Data(length(BIS_SQI_Data));
            BIS_SQI_Error_Time(length(BIS_SQI_Error_Time)+1) = Time_Elapse;
        end;
    else
        BIS_SQI_Data(length(BIS_SQI_Data) +1) = str2double(BIS_SQI);
    end;
    
    %%% Save Heart Rate array    %%%
    if (str2double(Heart_Rate)< 0)
        if (isempty(Heart_Rate_Data))
            Heart_Rate_Data(1)= 0;
            Heart_Rate_Error(1)=0;
            Heart_Rate_Error_Time(1)= Time_Elapse;
        else
            Heart_Rate_Data(length(Heart_Rate_Data) +1) = Heart_Rate_Data(length(Heart_Rate_Data));
            Heart_Rate_Error(length(Heart_Rate_Error)+1)= Heart_Rate_Data(length(Heart_Rate_Data));
            Heart_Rate_Error_Time(length(Heart_Rate_Error_Time)+1) = Time_Elapse;
        end;
    else
        Heart_Rate_Data(length(Heart_Rate_Data) +1) = str2double(Heart_Rate);
    end;
    
    %%% Save T1 array    %%%
    if T1< 0
        if (isempty(T1_Data))
            T1_Data(1)= 0;
            T1_Error(1)=0;
            T1_Error_Time(1)= Time_Elapse;
        else
            T1_Data(length(T1_Data) +1) = T1_Data(length(T1_Data));
            T1_Error(length(T1_Error)+1)= T1_Data(length(T1_Data));
            T1_Error_Time(length(T1_Error_Time)+1) = Time_Elapse;
        end;
    else
        T1_Data(length(T1_Data) +1) = T1;
    end;
        
    %%% Save Tratio array    %%%
    if (str2double(Tratio)< 0)
        if (isempty(Tratio_Data))
            Tratio_Data(1)= 0;
            Tratio_Error(1)=0;
            Tratio_Error_Time(1)= Time_Elapse;
        else
            Tratio_Data(length(Tratio_Data) +1) = Tratio_Data(length(Tratio_Data));
            Tratio_Error(length(Tratio_Error)+1)= Tratio_Data(length(Tratio_Data));
            Tratio_Error_Time(length(Tratio_Error_Time)+1) = Time_Elapse;
        end;
    else
        Tratio_Data(length(Tratio_Data) +1) = str2double(Tratio);
    end;
    
   
    %     %%%%% Plot the selected variables  %%%%%%%%%%%
    
    Refresh_Plot_1();
    
    %%%%% Display this six variables %%%%%%%%%%
    if (str2double(BIS) > 0)
        set(Label_12, 'String', str2double(BIS));
    else 
        set(Label_12, 'String', 'No valid');
    end
    if (str2double(BIS_EMG)> 0)
        set(Label_13, 'String', str2double(BIS_EMG));
    else 
        set(Label_13, 'String', 'No valid');
    end
    if (str2double(BIS_SQI)> 0)
        set(Label_14, 'String', str2double(BIS_SQI));
    else 
        set(Label_14, 'String', 'No valid');
    end
    if (str2double(Heart_Rate)> 0)
        set(Label_15, 'String', str2double(Heart_Rate));
    else 
        set(Label_15, 'String', 'No valid');
    end
    if (str2double(T1)> 0)
        set(Label_16, 'String', str2double(T1));
    else 
        set(Label_16, 'String', 'No valid');
    end
    if (str2double(Tratio)> 0)
        set(Label_17, 'String', str2double(Tratio));
    else 
        set(Label_17, 'String', 'No valid');
    end
    
    %%%%% Represent NMT gruop in bar digram %%%%
    if T1 >= 0
        if T1 > 0
            Value = T1/100;
            set(Bar_T1,'Position',[0.022 0 .22 Value]);
            Ref = T1_abs*100/T1;
            if T2_abs > 0
                Value = T2_abs/Ref;
                set(Bar_T2,'Position',[0.264 0 .22 Value]);
            end
            if T3_abs > 0
                Value = T3_abs/Ref;
                set(Bar_T3,'Position',[0.508 0 .22 Value]);
            end
            if T4_abs > 0
                Value = T4_abs/Ref;
                set(Bar_T4,'Position',[0.752 0 .22 Value]);
            end
        else
            set(Bar_T1,'Position',[0.022 0 .22 0.01]);
            set(Bar_T2,'Position',[0.264 0 .22 0.01]);
            set(Bar_T3,'Position',[0.508 0 .22 0.01]);
            set(Bar_T4,'Position',[0.752 0 .22 0.01]);
        end
        set(Bar_T1,'backgroundcolor','b');
        set(Bar_T2,'backgroundcolor','b');
        set(Bar_T3,'backgroundcolor','b');
        set(Bar_T4,'backgroundcolor','b');
        
    else
        set(Bar_T1,'backgroundcolor','w');
        set(Bar_T2,'backgroundcolor','w');
        set(Bar_T3,'backgroundcolor','w');
        set(Bar_T4,'backgroundcolor','w');
    end    
end

end






