%%% This funtion is implementes each sampling time of Pump 1            %%%
%%% This function does the following actions                            %%%
%%%     1. To Read the message in the Pump 1 UDP sockects (local port)  %%%    
%%%     2. To decode the UDP messages                                   %%% 
%%%     3. To Display and plot the main variables                       %%%
%%%     4. In "Automatic" control mode:                                 %%%
%%%             (1) It call the corresponding function to determine the %%%
%%%                 infusion rate value ("Function_Automatic_Control_1")%%%
%%%             (2) It Sends to UDP sockects (PUMP 1) remote port)      %%%
%%%                 the infusion rate value                             %%% 
%%% Luis Alberto Paz Surez                                             %%%
%%% 2010-08-17                                                          %%%


function Timer_Pump_1_Function()
global Sampling_Time_Pump1 Time_Elapse_Pump1 Time_AXES Flag_AXES_Shift;
global Plot_3;

global u2 u3 Ch_7;
global Label_26 Label_26a;

global Pump_1_UDP_Port_Read;
global Pump_1_UDP_Port_Write;
global sockcon_2;
global Pump_1_Value Pump_2_Value Pump_3_Value;

global Sampling_Time_1 Real_Time_1 BIS BIS_EMG BIS_SQI BIS_SupRat Heart_Rate T1 Tratio;
global Stimulus_Mode Pulse_Width T1_abs T2_abs T3_abs T4_abs;

global Sampling_Time_2 Real_Time_2 INF_Mode_1 INF_Rate_Value_1 INF_Rate_Value_Unit_1 
global Drug_Name_1 INF_VI_Value_1 INF_VI_Unit_1 INF_Pressure_Value_1 INF_Pressure_Unit_1
global INF_Time_Remain_1 Log_Type_1 Latest_Log_Entry_1

global Time_Pump1_Data INF_Rate_Pum1_Data;

Time_Elapse_Pump1 = Time_Elapse_Pump1 + Sampling_Time_Pump1;

%%% Syringe Pump 1 manipulation  %%%
%%% get data from Syringe pump 1  %%%
if sockcon_2 == -1
    sockcon_2 = pnet('udpsocket', Pump_1_UDP_Port_Read);
    pnet(sockcon_2,'setwritetimeout',1);
    pnet(sockcon_2,'setreadtimeout',0);
end
Pump1_message = Function_UDP_Read(sockcon_2);

if length(Pump1_message) > 1
    %%%% Decode and display Pump-1 message %%%
    Decode_Pump1_UDP_message(Pump1_message)
    
    %%%  Save array with the plot variables
    Time_Pump1_Data(length(Time_Pump1_Data) +1 ) = Time_Elapse_Pump1; 
    INF_Rate_Pum1_Data(length(INF_Rate_Pum1_Data) + 1) = str2num(INF_Rate_Value_1);
    
    %%% Set the x axes lim  %%%
    if Flag_AXES_Shift == 0
        time = Time_Pump1_Data(length(Time_Pump1_Data))/60;
        X3_LIM = xlim(Plot_3);
        if time > X3_LIM(2)
            X3_LIM(2)= X3_LIM(2) + Time_AXES/3;
            X3_LIM(1)= X3_LIM(1) + Time_AXES/3;
            xlim(Plot_3, X3_LIM);
        end
    end
    
    %%%%% Plot the selected variables  %%%%%%%%%%%    
    if (get(Ch_7,'Value') == get(Ch_7,'Max'))
        plot(Plot_3, Time_Pump1_Data/60, INF_Rate_Pum1_Data, 'b', 'LineWidth',2); 
    end
    %%%% Display de INF rate of the pump 1 %%%%%%%%
    if (str2double(INF_Rate_Value_1)> 0)
        set(Label_26, 'String', str2double(INF_Rate_Value_1));
    else 
        set(Label_26, 'String', 'No valid');
    end
end

if (get(u2,'Value') == get(u2,'Max'))
	% Syringe Pump 1 is in manual control mode
    % the value of INF_Rate is sended to the remote UDP port of Pump 1 
    % when button "Acept" is clicked, this call the funtion "Function_Validate_INF_Rate_1"
end

if (get(u3,'Value') == get(u3,'Max'))
	% Syringe Pump 1 is in automatic control mode, the value of INF_Rate is
	% determined by the Automatic control function, (see the next line) 
    % Pump_1_Value = Function_Automatic_Control_1(Input_1, Input_2, .... Inpu_n)
    % The input of Function_Automatic_Control_1 can be the variables of
    % DATEX message
    Pump_1_Value = Function_Automatic_Control_1();
    Remote_Host = 'localhost';
    Remote_Port = Pump_1_UDP_Port_Write;
    Data_to_Send = num2str(Pump_1_Value);
    set(Label_26a, 'String', Data_to_Send);
    %%% Send the infusion rate value to Pump 1 UDP sockect (romete port)%%%
    Function_UDP_Send(Remote_Host, sockcon_2, Remote_Port, Data_to_Send);
end


