%%% This funtion is implementes each sampling time of Pump 2            %%%
%%% This function does the following actions                            %%%
%%%     1. To Read the message in the Pump 2 UDP sockects (local port)  %%%    
%%%     2. To decode the UDP messages                                   %%% 
%%%     3. To Display and plot the main variables                       %%%
%%%     4. In "Automatic" control mode:                                 %%%
%%%             (1) Call the corresponding function to determine the %%%
%%%                 infusion rate value ("Function_Automatic_Control_2")%%%
%%%             (2) Send to UDP sockects (PUMP 2) remote port)      %%%
%%%                 the infusion rate value                             %%% 
%%% Luis Alberto Paz Surez                                             %%%
%%% 2010-08-17                                                          %%%


function Timer_Pump_2_Function()
global Sampling_Time_Pump2 Time_Elapse_Pump2 Time_AXES Flag_AXES_Shift;
global Plot_3;

global u5 u6 Ch_8;
global Label_27 Label_27a;

global Pump_2_UDP_Port_Read;
global Pump_2_UDP_Port_Write;
global sockcon_3;
global Pump_1_Value Pump_2_Value Pump_3_Value;

global Sampling_Time_1 Real_Time_1 BIS BIS_EMG BIS_SQI BIS_SupRat Heart_Rate T1 Tratio;
global Stimulus_Mode Pulse_Width T1_abs T2_abs T3_abs T4_abs;

global Sampling_Time_3 Real_Time_3 INF_Mode_2 INF_Rate_Value_2 INF_Rate_Value_Unit_2 
global Drug_Name_2 INF_VI_Value_2 INF_VI_Unit_2 INF_Pressure_Value_2 INF_Pressure_Unit_2
global INF_Time_Remain_2 Log_Type_2 Latest_Log_Entry_2

global Time_Pump2_Data INF_Rate_Pum2_Data;

Time_Elapse_Pump2 = Time_Elapse_Pump2 + Sampling_Time_Pump2;

%%%%%%%%%% Syringe Pump 2 manipulation  %%%%%%%%%%%%
%%%%%%%%%% get data from Syringe pump 2 %%%%%%%
if sockcon_3 == -1
    sockcon_3 = pnet('udpsocket', Pump_2_UDP_Port_Read);
    pnet(sockcon_3,'setwritetimeout',1);
    pnet(sockcon_3,'setreadtimeout',0);
end

Pump2_message = Function_UDP_Read(sockcon_3);

if length(Pump2_message) > 1
     Decode_Pump2_UDP_message(Pump2_message)
     
     %%%  Save array with the plot variables
     Time_Pump2_Data(length(Time_Pump2_Data) +1 ) = Time_Elapse_Pump2; 
     INF_Rate_Pum2_Data(length(INF_Rate_Pum2_Data) + 1) = str2double(INF_Rate_Value_2);
     
     %%% Set the x axes lim  %%%
     if Flag_AXES_Shift == 0
         time = Time_Pump2_Data(length(Time_Pump2_Data))/60;
         X3_LIM = xlim(Plot_3);
         if time > X3_LIM(2)
             X3_LIM(2)= X3_LIM(2) + Time_AXES/3;
             X3_LIM(1)= X3_LIM(1) + Time_AXES/3;
             xlim(Plot_3, X3_LIM);
         end
     end
     
     %%% Plot the selected variables
     if (get(Ch_8,'Value') == get(Ch_8,'Max'))
         plot(Plot_3, Time_Pump2_Data/60, INF_Rate_Pum2_Data, 'r', 'LineWidth',2);
     end
%     %%%% Display de INF rate of the pump 2 %%%%%%%%
    if (str2double(INF_Rate_Value_2)> 0)
        set(Label_27, 'String', str2double(INF_Rate_Value_2));
    else 
        set(Label_27, 'String', 'No valid');
    end
end

if (get(u5,'Value') == get(u5,'Max'))
    % Syringe Pump 2 is in manual control mode
    % the value of INF_Rate is sended to the remote UDP port of Pump 2 
    % when button "Acept" is clicked, this call the funtion
    % "Function_Validate_INF_Rate_2"
    
end
if (get(u6,'Value') == get(u6,'Max'))
	% Syringe Pump 2 is in automatic control mode, the value of INF_Rate is
	% determined by the Automatic control function, (see the next line) 
    % Pump_2_Value = Function_Automatic_Control_2(Input_1, Input_2, .... Inpu_n)
    % The input of Function_Automatic_Control_2 can be the variables of
    % DATEX message
    Pump_2_Value = Function_Automatic_Control_2();
    Remote_Host = 'localhost';
    Remote_Port = Pump_2_UDP_Port_Write;
    Data_to_Send = num2str(Pump_2_Value);
    set(Label_27a, 'String', Data_to_Send);
    %%% Send the infusion rate value to Pump 2 UDP sockect (romete port)%%%
    Function_UDP_Send(Remote_Host, sockcon_3, Remote_Port, Data_to_Send);
end


