%%% This funtion is implementes each sampling time of Pump 3            %%%
%%% This function does the following actions                            %%%
%%%     1. To Read the message in the Pump 3 UDP sockects (local port)  %%%    
%%%     2. To decode the UDP messages                                   %%% 
%%%     3. To Display and plot the main variables                       %%%
%%%     4. In "Automatic" control mode:                                 %%%
%%%             (1) It call the corresponding function to determine the %%%
%%%                 infusion rate value ("Function_Automatic_Control_3")%%%
%%%             (2) It Sends to UDP sockects (PUMP 3) remote port)      %%%
%%%                 the infusion rate value                             %%% 
%%% Luis Alberto Paz Surez                                             %%%
%%% 2010-08-17                                                          %%%


function Timer_Pump_3_Function()
global Sampling_Time_Pump3 Time_Elapse_Pump3 Time_AXES Flag_AXES_Shift;
global Plot_3;

global u5_N u6_N Ch_9;
global Label_27C Label_27E;

global Pump_3_UDP_Port_Read;
global Pump_3_UDP_Port_Write;
global sockcon_4;
global Pump_1_Value Pump_2_Value Pump_3_Value;

global Sampling_Time_1 Real_Time_1 BIS BIS_EMG BIS_SQI BIS_SupRat Heart_Rate T1 Tratio;
global Stimulus_Mode Pulse_Width T1_abs T2_abs T3_abs T4_abs;

global Sampling_Time_4 Real_Time_4 INF_Mode_3 INF_Rate_Value_3 INF_Rate_Value_Unit_3 
global Drug_Name_3 INF_VI_Value_3 INF_VI_Unit_3 INF_Pressure_Value_3 INF_Pressure_Unit_3
global INF_Time_Remain_3 Log_Type_3 Latest_Log_Entry_3

global Time_Pump3_Data INF_Rate_Pum3_Data;

Time_Elapse_Pump3 = Time_Elapse_Pump3 + Sampling_Time_Pump3;

%%%%%%%%% Syringe Pump 3 manipulation  %%%%%%%%%%%%
%%%%%%%%% get data from Syringe pump 3 %%%%%%%
if sockcon_4 == -1
    sockcon_4 = pnet('udpsocket', Pump_3_UDP_Port_Read);
    pnet(sockcon_4,'setwritetimeout',1);
    pnet(sockcon_4,'setreadtimeout',0);
end
Pump3_message = Function_UDP_Read(sockcon_4);

if length(Pump3_message) > 1
     Decode_Pump3_UDP_message(Pump3_message)
     
     %%%  Save array with the plot variables
     Time_Pump3_Data(length(Time_Pump3_Data) +1 ) = Time_Elapse_Pump3; 
     INF_Rate_Pum3_Data(length(INF_Rate_Pum3_Data) + 1) = str2double(INF_Rate_Value_3);

     %%% Set the x axes lim  %%%
     if Flag_AXES_Shift == 0
         time = Time_Pump3_Data(length(Time_Pump3_Data))/60;
         X3_LIM = xlim(Plot_3);
         if time > X3_LIM(2)
             X3_LIM(2)= X3_LIM(2) + Time_AXES/3;
             X3_LIM(1)= X3_LIM(1) + Time_AXES/3;
             xlim(Plot_3, X3_LIM);
         end
     end
     
     %%% Plot the selected variables  
     if (get(Ch_9,'Value') == get(Ch_9,'Max'))
         plot(Plot_3, Time_Pump3_Data/60, INF_Rate_Pum3_Data, 'm', 'LineWidth',2);
     end
     
     %     %%%% Display de INF rate of the pump 3 %%%%%%%%
     if (str2double(INF_Rate_Value_3)> 0)
         set(Label_27C, 'String', str2double(INF_Rate_Value_3));
     else
         set(Label_27C, 'String', 'No valid');
     end
end

if (get(u5_N,'Value') == get(u5_N,'Max'))
    % Syringe Pump 3 is in manual control mode
    % the value of INF_Rate is sended to the remote UDP port of Pump 3 
    % when button "Acept" is clicked, this call the funtion
    % "Function_Validate_INF_Rate_3"
    
end
if (get(u6_N,'Value') == get(u6_N,'Max'))
	% Syringe Pump 3 is in automatic control mode, the value of INF_Rate is
	% determined by the Automatic control function, (see the next line) 
    % Pump_3_Value = Function_Automatic_Control_3(Input_1, Input_2, .... Inpu_n)
    % The input of Function_Automatic_Control_3 can be the variables of
    % DATEX message
    Pump_3_Value = Function_Automatic_Control_3();
    Remote_Host = 'localhost';
    Remote_Port = Pump_3_UDP_Port_Write;
    Data_to_Send = num2str(Pump_3_Value);
    set(Label_27E, 'String', Data_to_Send);
    %%% Send the infusion rate value to Pump 2 UDP sockect (romete port)%%%
    Function_UDP_Send(Remote_Host, sockcon_3, Remote_Port, Data_to_Send);
end


