%%% This funtion is implementes timer Simulator                         %%%
%%% This function does the following actions                            %%%
%%%
%%%
%%%
%%% Luis Alberto Paz Surez                                             %%%
%%% 2010-08-17                                                          %%%


function Timer_Simulator_Function()
global Timer_Simulator  Plot_1 Plot_2 Plot_3;
global Master Manual_C Noise_Rate Time_Sim Ts TS_Plot Index ALPHA GAMMA C50 Flag_Filter B_Filt;
global Kc Ti Td T50 Flag_10 Flag_Change Flag_Start_Control Flag_T50 Flag_PCA;
global NMB_Model NMB_Model_Filt Ref_NMB Control_1 X_NMB SP_NMB E_NMB Temp A_Dcrt B_Dcrt C_Dcrt;
global Flag_Tunning Cont_TTunning_1 Cont_TTunning_2 Ind_T_1 Ind_T_2
Model = get(findobj('tag','PpM_Model'),'Value');
Controller = get(findobj('tag','PpM_Control'),'Value');
Index = Index + 1;
u = Control_1(Index-1);

%%% Determine the model output %%%%%
if Model == 3
    %%% Case of DATA FILE
else
    %%% Case Reduced Model or PK-PD Model
    X0 = X_NMB;
    [Ymodel State] = Discret_NMB_Space_State_Model(u, X0, Model);
    Noise_Value = (1-2*rand(1,1))*Noise_Rate;
    NMB_Model(Index) = Ymodel + Noise_Value;
    %%%% Ask if filter is enabled %%%%%%%
    if (Flag_Filter ~= 0)
        % Fitro de primer orden
        if (abs(NMB_Model(Index)-NMB_Model(Index -1))>5)
            NMB_Model(Index) = NMB_Model(Index-1) + 5*sign(NMB_Model(Index)-NMB_Model(Index -1));
        end
        % Filtro FIR orden 20
        if (Index >25)
            ACC = 0;
            ORD_F = 10;
            
            for k = 1:ORD_F +1;
                ACC = ACC + B_Filt(k)*NMB_Model(Index - k + 1);
            end
            NMB_Model_Filt(Index) = ACC;
        else
            NMB_Model_Filt(Index) = NMB_Model(Index);
        end
    else
        NMB_Model_Filt(Index) = NMB_Model(Index);
    end
    
    X_NMB = State;
    Time_Sim(Index) = Ts*Index;
    SP_NMB(Index) = Ref_NMB;
    E_NMB(Index) = SP_NMB(Index) - NMB_Model_Filt(Index) ;
end

% To determine the control action
% There are four controllers class
if (Controller == 3)    % To Determine the parameter T50
    if ((NMB_Model(Index) <= 50) && (Flag_T50 == 0))
        %
        Pend = (NMB_Model(Index) - NMB_Model(Index-1))/Ts;
        Dezp = NMB_Model(Index) - Pend*Index*Ts;
        T50 = (50 - Dezp)/Pend;
        Flag_T50 = 1;
        % Tunning the PID (based in T50)
        Mc = get(findobj('tag','PpM_Case_Control'),'Value');     % Modelo a utilizar (Controller)
        load Param_NMB
        R1 = 148.108 + 35.518*T50;
        R = 1/R1;
        L = 1.229 + 1.167*T50;
        S = S_v(Mc); C50_c = C50_v(Mc);
        
        % Idem in the (PID-Fixo, PID-T50, PID-PCA)
        RD = (-Ref_NMB^2*S*(100/Ref_NMB-1)^(1-1/S))/(100*C50_c);
        Kc = 1/(R*L*RD);     % Constante proporcional
        Ti = 4*L;            % Tempo de Integrao (Diferencia com Magalhaes Ti = 2*L)
        Td = L/2;            % Tempo Derivativo
        Temp(Index) = Kc*Ts*E_NMB(1)/Ti;
    end
end

if (Controller == 4)    % Determine the parameter PCA
    % Calculo do PCA
    if ((Index == 30) && (Flag_PCA == 0))
        % Tunning the PID (based in PCA)
        Mc = get(findobj('tag','PpM_Case_Control'),'Value');     % Modelo a utilizar (Controller)
        load Param_PCA
        load Param_NMB
        Yfilt = [NMB_Model(4:end) NMB_Model(end-2: end)];
        Coef = (Yfilt-media)*CP;
        R1 = 217.0317-0.2478*Coef(:,1)-0.3025*Coef(:,2)+0.3690*Coef(:,3);
        R = 1./R1;
        L = 3.4928-0.005*Coef(:,1)-0.0003*Coef(:,2)+0.0118*Coef(:,3);
        Flag_PCA = 1;
        S = S_v(Mc); C50_c = C50_v(Mc);
        
        % Idem in the (PID-Fixo, PID-T50, PID-PCA)
        RD = (-Ref_NMB^2*S*(100/Ref_NMB-1)^(1-1/S))/(100*C50_c);
        Kc = 1/(R*L*RD);     % Constante proporcional
        Ti = 4*L;            % Tempo de Integrao (Diferencia com Magalhaes Ti = 2*L)
        Td = L/2;            % Tempo Derivativo
        Temp(Index) = Kc*Ts*E_NMB(1)/Ti;
        
    end
end

% Algorith of four controllers
% The control action is calculated if the NMB is rising and is above 7.5
% Condition 1
if ((NMB_Model(Index) < 10) && (Flag_10 == 0))
    Flag_10 = 1;
end

if (Flag_10 == 0)
    Control_1(Index) = 0;
    Temp(Index) = Temp(Index-1);
elseif (Flag_Change == 0)
    if (NMB_Model(Index) > NMB_Model(Index -1))
        Flag_Change = 1;
    end
    Control_1(Index) = 0;
    Temp(Index) = Temp(Index-1);
    %Condition 2
elseif (Flag_Start_Control == 0)
    if NMB_Model(Index)>=7.5
        Flag_Start_Control = 1;
    end
    Control_1(Index) = Control_1(Index - 1);
    Temp(Index) = Temp(Index-1);
else
    % Exist the two necessary conditions to apply the control action
    if (Controller == 3) && (Flag_T50 == 0)
        errordlg('T50 parameter do not found','Autotunning Error');
        stop(Timer_Simulator)
    end
    if (Controller == 4) && (Flag_PCA == 0)
        errordlg('PCA parameter do not found','Autotunning Error');
        stop(Timer_Simulator)
    end
    
    %%%%%%%%%%%%%%%%%%% PID Controller Equation %%%%%%%%%%%%%%%%%%%%%%%
    Control_1(Index) = Temp(Index-1) + Kc*E_NMB(Index) + Kc*Td*(E_NMB(Index) - E_NMB(Index-1))/Ts;
    Temp(Index) = Temp(Index-1) + Kc*Ts*E_NMB(Index)/Ti;
    
    if (Control_1(Index) < 0)
        Control_1(Index) = 0;
        Temp(Index) = Temp(Index-1);    % Avoid saturation of the controller
    end
    if (Control_1(Index) >1200)
        Control_1(Index) = 1200;
        Temp(Index) = Temp(Index-1);    % Avoid saturation of the controller
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if (Master == 1)
        %%%%% Automatic control  %%%%%%
        
    else
        %%%%% Manual Control %%%%%%%%%%
        Control_1(Index)= Manual_C;
        Temp(Index) = Temp(Index-1);    % Avoid saturation of the controller
        if Flag_Tunning == 1
            try
                if (Cont_TTunning_1 < 30)
                    Cont_TTunning_1 = Cont_TTunning_1 +1;
                else
                    Pulse_T = 60;
                    if Cont_TTunning_2 == 0
                        Ind_T_1 = Index ;
                        Manual_C = Manual_C + 0.5;
                    end
                    if Cont_TTunning_2 == Pulse_T
                        Ind_T_2 = Index;
                        KT1 = (NMB_Model(Ind_T_2) - NMB_Model(Ind_T_1))/(Control_1(Ind_T_2)-Control_1(Ind_T_1));
                        Area_2 = zeros(Pulse_T,1);
                        for cont = 2:Pulse_T
                            Area_2(cont)= abs(((NMB_Model(Ind_T_1 + cont)+ NMB_Model(Ind_T_1 + cont -1))/2)*Ts - NMB_Model(Ind_T_1)*Ts)+ Area_2(cont-1);
                        end
                        Area_2(Pulse_T)
                        Area_0 = abs(KT1)*Ts*Pulse_T - Area_2(Pulse_T);
                        TL = Area_0/abs(KT1);
                        Area_1 = Area_2(floor(TL/Ts))   ;
                        Cont_T = 2.78*Area_1/abs(KT1);
                        Cont_L = TL - Cont_T;
                        Cont_a = KT1*Cont_L/Cont_T;
                        Kc_new = 1.2*Cont_a;
                        Ti_new = 4*Cont_L;
                        Td_new = Cont_L/2;
                        Flag_Tunning = 0;
                        Manual_C = Manual_C - 0.5;
                        % stop(Timer_Simulator)
                        %%%% Ask if update the new PID Parameters
                        options.Interpreter = 'tex';
                        options.Default = 'Cancel';
                        % Create a TeX string for the question
                        str_1 = strcat('\bf Kc =',num2str(Kc_new), ',  Ti =', num2str(Ti_new), ',  Td =', num2str(Td_new),'\rm\newline \newline');
                        str_2 = 'You want update this parameters?';
                        
                        qstring = strcat(str_1, str_2);
                        Bt_T_Dlg = questdlg(qstring,'PID Auto-Tunning Parameters',...
                            'Yes','No','Cancel',options);
                        
                        switch Bt_T_Dlg,
                            case 'Yes',
                                Kc = Kc_new;
                                Ti = Ti_new;
                                Td = Td_new;
                                %start(Timer_Simulator)
                            case 'No',
                                %start(Timer_Simulator)
                                
                            case 'Cancel',
                                %start(Timer_Simulator)
                                
                        end % switch
                        set(findobj('tag','RB_Auto'),'Value',1)
                        Master = 1;
                    end
                    Cont_TTunning_2 = Cont_TTunning_2 +1;
                end
            catch ME
                msgbox('Auto-tuning was not possible','Auto-Tunning Error','error')
            end
        end
    end
    
end





% Display and plot the main variables
set(findobj('tag','BEdit_NMB'),'string',num2str(ceil(NMB_Model(Index)*100)/100))
set(findobj('tag','BEdit_Pump1'),'string',num2str(ceil(Control_1(Index)*100)/100))

TS_Plot = TS_Plot + 1;
if (TS_Plot == 20)
    TS_Plot = 0;
    %%%%%%    Plot the variables NMB and PUMP-1
    cla(Plot_2);
    X1_LIM = [0 Time_Sim(Index)];
    xlim(Plot_2, X1_LIM);
    plot(Plot_2, Time_Sim, NMB_Model_Filt)
    plot(Plot_2, Time_Sim, NMB_Model,'r')
    hold(Plot_2,'on')
    plot(Plot_2, Time_Sim, SP_NMB, '--r')
    
    cla(Plot_3);
    xlim(Plot_3, X1_LIM);
    plot(Plot_3, Time_Sim, Control_1)
end

end
